/* 
 * Intellavia GoogleTracker Plugin © 2012
 * 
 * This plugin is free to use and modify as needed. Enjoy.
 * 
 * Author: Ryan Mills
 * Date:   03/27/2012
 */

function cleanText( input ) {
    var cleanText = input;
    
    cleanText = cleanText.replace(/'/g,"\\'");
    
    return cleanText;
}

CKEDITOR.plugins.add('googletracker',
{
    init: function(editor) {
        var pluginName = 'googletracker';
        var iconPath = CKEDITOR.plugins.getPath(pluginName) + '/images/googletracker.png';
        
        editor.addCommand(pluginName, new CKEDITOR.dialogCommand(pluginName));
        // add the button to the ui
        editor.ui.addButton('GoogleTracker',
        {
            label: 'Google Event/Page Tracking',
            command: pluginName,
            icon: iconPath
        });
        
        editor.on('selectionChange', function(evt) {
            if ( editor.readOnly ) return;
            
            var command = editor.getCommand(pluginName), 
                element = evt.data.path.lastElement && evt.data.path.lastElement.getAscendant('a', true);
                
            if( element && element.getName() == 'a' && element.getAttribute('href') && element.getChildCount() ) {
                command.setState( CKEDITOR.TRISTATE_OFF );  
            } else {
                command.setState( CKEDITOR.TRISTATE_DISABLED );
            }   
            
        });
        
        if ( editor.contextMenu )
        {
            editor.addMenuGroup('googleanalytics', 10);
            
            editor.addMenuItem('googleanalyticItem', {
                label: 'Google Event/Page Tracking',
                icon: iconPath,
                command: pluginName,
                group: 'googleanalytics',
                order: 1
            });
            
            editor.contextMenu.addListener( function( element, selection ) {
                if ( !element ) 
                    return null;

                if ( element.is('a') )
                    return {googleanalyticItem: CKEDITOR.TRISTATE_OFF};


                return null;
            });
        }
        
        // add dialog
        CKEDITOR.dialog.add(pluginName, function(editor) {
            var anchorCateogry, anchorText, anchorLabel;
            
            return {
                title : "Add Google Event/Page Tracker",
                minWidth : "400",
                minHeight : "220",
                contents: [
                {
                    id: 'tab1',
                    label: 'Settings',
                    elements: [
                    {
                        type: 'select',
                        id: 'type',
                        label: 'Type',
                        items: [ ['none'], [ '_trackEvent' ], [ '_trackPageview' ] ],
                        'default': 'none',
                        setup: function( element ) {
                            if(element[0]) {
                                this.setValue(element);
                            }
                        },
                        commit: function( element ) {

                        	if (this.getValue() == 'none') {
 								if(element.is('a')) {
	                                element.removeAttribute('data-tracking');
	                            } else if(element.getParent().is('a')) {
	                                element.getParent().removeAttribute('data-tracking');
	                            }
                        	} else {
                        		if(element.is('a')) {
	                                element.removeAttribute('data-tracking');
	                                element.setAttribute('data-tracking', this.getValue());
	                            } else if(element.getParent().is('a')) {
	                                element.getParent().removeAttribute('data-tracking');
	                                element.getParent().setAttribute('data-tracking', this.getValue());
	                            }
                        	}
                           
                        }
                    }
                    ]
                }],
                onOk: function() {
                    var dialog = this;
                    var element = this.element;
             
                    var category = cleanText(dialog.getValueOf('tab1', 'type'));
 
                    if(element.is('a')) {
                        element.removeAttribute('data-tracking');
                        element.setAttribute('data-tracking', category);
                    } else if(element.getParent().is('a')) {
                        element.getParent().removeAttribute('data-tracking');
                        element.getParent().setAttribute('data-tracking', category);
                    } else {
                        CKEDITOR.dialog.getCurrent().hide();
                        alert('Please select an anchor element'); 
                    }

                    this.commitContent(element);
                },
                onShow: function() {
                    var element = editor.getSelection().getStartElement();
                   
                    var temp = element.getAttribute('data-tracking');
 
                    this.element = element;
                    
                    if( temp = element.getAttribute('data-tracking') ) {
                        this.setupContent(temp);
                    } else if( temp = element.getParent().getAttribute('data-tracking') ) {
                        this.setupContent(temp);
                    }
                    
                    if(!element.is('a') && !element.getParent().is('a')) {
                        CKEDITOR.dialog.getCurrent().hide();
                        alert('Please select an anchor element'); 
                    }
                } 
            }
           
    
        });
        
    }
}
);
